Index: extensions/CMakeLists.txt
===================================================================
--- extensions/CMakeLists.txt	(revision 1020)
+++ extensions/CMakeLists.txt	(revision 1040)
@@ -72,4 +72,6 @@
 FD_EXTENSION_SUBDIR(rt_busypeers "Handling of Diameter TOO_BUSY messages and relay timeouts"	ON)
 FD_EXTENSION_SUBDIR(rt_ereg      "Configurable routing based on regexp matching of AVP values" OFF)
+FD_EXTENSION_SUBDIR(rt_ignore_dh "Stow Destination-Host in Proxy-Info, restore to Origin-Host for answers"	ON)
+FD_EXTENSION_SUBDIR(rt_load_balance "Balance load over multiple equal hosts, based on outstanding requests"	ON)
 
 
Index: extensions/app_diameap/diameap_tls.h
===================================================================
--- extensions/app_diameap/diameap_tls.h	(revision 1034)
+++ extensions/app_diameap/diameap_tls.h	(revision 1033)
@@ -40,26 +40,10 @@
 #define DIAMEAP_TLS_H_
 
- #if defined(__GNUC__) && ((__GNUC__ * 100) + __GNUC_MINOR__) >= 405
-# define GCC_DIAG_DO_PRAGMA(x) _Pragma (#x)
-# define GCC_DIAG_PRAGMA(x) GCC_DIAG_DO_PRAGMA(GCC diagnostic x)
-# if ((__GNUC__ * 100) + __GNUC_MINOR__) >= 406
-#  define GCC_DIAG_OFF(x) GCC_DIAG_PRAGMA(push) \
-     GCC_DIAG_PRAGMA(ignored x)
-#  define GCC_DIAG_ON(x) GCC_DIAG_PRAGMA(pop)
-# else
-#  define GCC_DIAG_OFF(x) GCC_DIAG_PRAGMA(ignored x)
-#  define GCC_DIAG_ON(x)  GCC_DIAG_PRAGMA(warning x)
-# endif
-#else
-# define GCC_DIAG_OFF(x)
-# define GCC_DIAG_ON(x)
-#endif
-
-
 #include "diameap_defs.h"
 #include <gnutls/gnutls.h>
-GCC_DIAG_OFF("-Wdeprecated-declarations")
+#pragma GCC diagnostic push
+#pragma GCC diagnostic ignored "-Wdeprecated-declarations"
 #include <gcrypt.h>
-GCC_DIAG_ON("-Wdeprecated-declarations")
+#pragma GCC diagnostic pop
 #include <errno.h>
 #include <pthread.h>
Index: extensions/app_diameap/libcrypt.h
===================================================================
--- extensions/app_diameap/libcrypt.h	(revision 1034)
+++ extensions/app_diameap/libcrypt.h	(revision 1033)
@@ -40,12 +40,12 @@
 #define LIBCRYPT_H_
 
+#pragma GCC diagnostic push
+#pragma GCC diagnostic ignored "-Wdeprecated-declarations"
+#include <gcrypt.h>
+#pragma GCC diagnostic pop
+#include <stdio.h>
+
 /* EAP-TLS*/
 #include "diameap_tls.h"
-
-GCC_DIAG_OFF("-Wdeprecated-declarations")
-#include <gcrypt.h>
-GCC_DIAG_ON("-Wdeprecated-declarations")
-#include <stdio.h>
-
 
 
Index: extensions/app_diameap/plugins/eap_md5/eap_md5.c
===================================================================
--- extensions/app_diameap/plugins/eap_md5/eap_md5.c	(revision 1034)
+++ extensions/app_diameap/plugins/eap_md5/eap_md5.c	(revision 1033)
@@ -38,7 +38,8 @@
 
 #include "../../plugins.h"
-GCC_DIAG_OFF("-Wdeprecated-declarations")
+#pragma GCC diagnostic push
+#pragma GCC diagnostic ignored "-Wdeprecated-declarations"
 #include <gcrypt.h>
-GCC_DIAG_ON("-Wdeprecated-declarations")
+#pragma GCC diagnostic pop
 
 #define CHALLENGE_LEN	16
Index: extensions/app_sip/app_sip.h
===================================================================
--- extensions/app_sip/app_sip.h	(revision 1034)
+++ extensions/app_sip/app_sip.h	(revision 1033)
@@ -39,7 +39,8 @@
 #include <stdlib.h>
 #include <stdio.h>
-GCC_DIAG_OFF("-Wdeprecated-declarations")
+#pragma GCC diagnostic push
+#pragma GCC diagnostic ignored "-Wdeprecated-declarations"
 #include <gcrypt.h>
-GCC_DIAG_ON("-Wdeprecated-declarations")
+#pragma GCC diagnostic pop
 #include <string.h>
 #include <mysql.h>
Index: extensions/rt_busypeers/CMakeLists.txt
===================================================================
--- extensions/rt_busypeers/CMakeLists.txt	(revision 1020)
+++ extensions/rt_busypeers/CMakeLists.txt	(revision 1040)
@@ -1,3 +1,3 @@
-# The rt_ereg extension
+# The rt_busypeer extension
 PROJECT("Handling of TOO_BUSY messages and relay timeout capability routing extension" C)
 
Index: extensions/test_sip/test_sip.h
===================================================================
--- extensions/test_sip/test_sip.h	(revision 1034)
+++ extensions/test_sip/test_sip.h	(revision 1033)
@@ -39,7 +39,8 @@
 #include <stdlib.h>
 #include <stdio.h>
-GCC_DIAG_OFF("-Wdeprecated-declarations")
+#pragma GCC diagnostic push
+#pragma GCC diagnostic ignored "-Wdeprecated-declarations"
 #include <gcrypt.h>
-GCC_DIAG_ON("-Wdeprecated-declarations")
+#pragma GCC diagnostic pop
 #include <string.h>
 #include <mysql.h>